This is an archived snapshot of W3C's public bugzilla bug tracker, decommissioned in April 2019. Please see the home page for more details.

Bug 11395 - Use media queries to select appropriate <track> elements
Summary: Use media queries to select appropriate <track> elements
Status: CLOSED WONTFIX
Alias: None
Product: HTML WG
Classification: Unclassified
Component: LC1 HTML5 spec (show other bugs)
Version: unspecified
Hardware: All All
: P2 normal
Target Milestone: ---
Assignee: John Foliot
QA Contact: HTML WG Bugzilla archive list
URL:
Whiteboard:
Keywords: a11y, media
Depends on:
Blocks:
 
Reported: 2010-11-24 02:45 UTC by Frank Olivier
Modified: 2011-08-04 05:13 UTC (History)
11 users (show)

See Also:


Attachments

Description Frank Olivier 2010-11-24 02:45:48 UTC
From http://www.w3.org/WAI/PF/HTML/wiki/Media_Accessibility_Checklist

(DAC-2) The user has a global option to specify which types of alternative content by default and, in cases where the alternative content has different dimensions than the original content, how the layout/reflow of the document should be handled. (UAAG 2.0 3.1.2).

CHANGE: 
http://dev.w3.org/html5/spec/Overview.html#the-track-element
Use media query strings instead of the 'kind' attribute concept.

User agents should enable users to set the media queries that they would like to match for track selection / content layout.
Comment 1 Philip J├Ągenstedt 2010-11-24 07:33:11 UTC
I don't see how it follows from the requirement that media queries be used. Browsers could just as well let the user set preferred language and indicate if they want HoH cues or not. Neither of these can be expressed by media queries.

Also, I don't understand what "in cases where the alternative content has different dimensions than the original content, how the layout/reflow of the document should be handled" means in practice. Layout is determined by CSS, it would be strange to have it depend on a user preference. User CSS might work, although it's not clear what the actual requirement is. (To avoid overlap?)
Comment 2 Anne 2010-11-24 12:32:22 UTC
I do not understand how Media Queries can help here. Users do not set/manipulate Media Queries, that is not how they work. (Are you trying to convey a proposal from David Singer by any chance?)
Comment 3 David Singer 2010-12-02 00:30:50 UTC
answering Anne, I think he may be, yes.

The basic idea is to mark <track> and <source> elements with a media query that is satisfied when a particular accessibility need is, or is not, requested.  That would make it possible to say "don't show this if the user is susceptible to repetitive stimulation", it would make it possible to say "this text <track> meets a sub-titling need (in Swahili)", and so on.  Media queries also make it possible for the rest of the page, including the layout, to respond as needed.
Comment 4 Silvia Pfeiffer 2010-12-02 03:42:34 UTC
My understanding of DAC-2 was that we are going to provide a menu that displays all available tracks to the user to let the enable/disable the track display.

On top of this, there will be user settings in browsers for the preferred tracks to be active by default. If the kind/lang combination of a track matches a user's preferences, the track will automatically be turned on.

As for the "repetitive stimuation" issue - I guess what you are saying is that a video that e.g. provides strobelight, and can cause seizures, should be marked as such and not play for people who may have indicated such an anit-preference in their browser. Are there any other such use cases where videos are dangerous to certain user groups and must not be shown to them at all (apart from porn, I guess)? I don't really think media queries are the right solution for that (since it's not a property of the display media that we are filtering on, but a user preference). I think it might be better to introduce another attribute for such things, something like @indication which can indicate what audience to avoid (e.g. adult, strobe etc).

Haven't made up my mind on this though, just thinking out loud...
Comment 5 David Singer 2010-12-04 00:11:50 UTC
Silvia: you're right, in that this is a slight extension of the 'display' to include the user's reception of the presented material, so it is a conceptual extension of media queries.

then, on "On top of this, there will be user settings in browsers for the preferred
tracks to be active by default. If the kind/lang combination of a track matches
a user's preferences, the track will automatically be turned on." -- we have a system that delivers an on/off signal, and it's called media queries.  Rather than inventing a new 'type' indicator, which is what we're doing, I'd like to explore using the existing one. 

Particularly, this (a) allows the rest of the page to respond as well (so, trivially, I could show something that confirms I see your preference "captions enabled") and (b) if we can 'style' the tracks in the video element as well as the element itself, then (perhaps) the layout of that element and the rest of the page can change (allowing by-side captioning rather than overlay, if desired, for example).

that was my broad vision, anyway...
Comment 6 Silvia Pfeiffer 2010-12-04 01:21:43 UTC
(In reply to comment #5)
> Silvia: you're right, in that this is a slight extension of the 'display' to
> include the user's reception of the presented material, so it is a conceptual
> extension of media queries.
> 
> then, on "On top of this, there will be user settings in browsers for the
> preferred
> tracks to be active by default. If the kind/lang combination of a track matches
> a user's preferences, the track will automatically be turned on." -- we have a
> system that delivers an on/off signal, and it's called media queries.  Rather
> than inventing a new 'type' indicator, which is what we're doing, I'd like to
> explore using the existing one.


It's not really a new system - browser preference language settings already influence what we see on the Web. The @kind attribute just adds the type of accessibility content to this existing feature.

 
> Particularly, this (a) allows the rest of the page to respond as well (so,
> trivially, I could show something that confirms I see your preference "captions
> enabled") and (b) if we can 'style' the tracks in the video element as well as
> the element itself, then (perhaps) the layout of that element and the rest of
> the page can change (allowing by-side captioning rather than overlay, if
> desired, for example).
> 
> that was my broad vision, anyway...

I'm curious what you mean by "the rest of the page responds" and "style the tracks". Are you talking about exposing the state to JavaScript, such that a JavaScript developer can then grab the captions in display them side-by-side rather than as overlay as they are displayed by default? Can you give a concrete example where the @media query works but the @kind/@lang attribute doesn't?
Comment 7 Ian 'Hixie' Hickson 2010-12-13 22:20:07 UTC
EDITOR'S RESPONSE: This is an Editor's Response to your comment. If you are satisfied with this response, please change the state of this bug to CLOSED. If you have additional information and would like the editor to reconsider, please reopen this bug. If you would like to escalate the issue to the full HTML Working Group, please add the TrackerRequest keyword to this bug, and suggest title and text for the tracker issue; or you may create a tracker issue yourself, if you are able to do so. For more details, see this document:
   http://dev.w3.org/html5/decision-policy/decision-policy.html

Status: Rejected
Change Description: no spec change yet
Rationale: Before we apply this to <track>, I think we should wait to have proven that it works with <source>. We can always add it to <track> later if it turns out that this works well.
Comment 8 Martin Kliehm 2011-01-10 20:01:41 UTC
I'd like to point out that bug 11593 partly addresses the same issue using the @kind attribute: a user needs to be enabled to make an informed decision which tracks are available and what kind of content they represent.

What isn't addressed by the other bug is the functionality of user preferences that are translated by the browser into some kind of default user style-sheet.

But the analogy of language preferences doesn't translate well because they also come with a priority, so I believe the concept of media queries doesn't quite reflect this. A media query is binary, true or false, but doesn't ask if "extended audio descriptions" are priority 0.9 while "audio descriptions" are 0.7.
Comment 9 Martin Kliehm 2011-01-11 17:13:18 UTC
The bug-triage sub-team doesn't think this particular bug needs to be HTML Accessibility Task Force priority. We think there's a consensus that taking user preferences as default settings would benefit users, but there's disagreement if media queries are the right tool.
Comment 10 Martin Kliehm 2011-01-11 18:08:47 UTC
Assigning to John Foliot to push the issue in the media group.
Comment 11 David Singer 2011-02-10 04:25:28 UTC
I think that this is being addressed in a different way so we should close it.
Comment 12 Michael[tm] Smith 2011-08-04 05:13:52 UTC
mass-move component to LC1